### This file created by BYACC 1.8(/Java extension  0.92)
### Java capabilities added 7 Jan 97, Bob Jamison
### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
###           01 Jun 99  -- Bob Jamison -- added Runnable support
### Please send bug reports to rjamison@lincom-asg.com
### static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";



#line 2 "cal.y"
  SYMBOL_TABLE = {}
  $result = nil
#line 13 "Parser.rb"




######################################################################
# class: Parser
# does : encapsulates yacc() parser functionality in a Java
#        class for quick code development
######################################################################
class Parser
  YYSTACKSIZE = 500 # maximum stack size

  def initialize
    @yydebug   = nil      # do I want debug output?
    @yynerrs   = nil      # number of errors so far
    @yyerrflag = nil      # was there an error?
    @yychar    = nil      # the current working character
    @statestk  = []       # state stack
    @stateptr  = nil      # state stack pointer
    @yytext    = nil      # user variable to return contextual strings
    @yyval     = nil      # used to return semantic vals from action routines
    @yylval    = nil      # the 'lval' (result) I got from yylex()
    @valstk    = []
    @valptr    = nil      #
    init_rule_data
    init_yydefred
    init_yydgoto
    init_base
    init_table
    init_check
    init_yyname
    init_yyrule
  end

###############################################################
# method: debug
################################################################
  def debug(msg)
    if (@yydebug)
      $stdout.print(msg,"\n")
    end
  end

  def yyerror(msg)
    $stderr.print(msg,"\n")
  end

################################################################
# methods: state stack push,pop,drop,peek
################################################################
def state_push(state)
  if (@stateptr >= YYSTACKSIZE) # overflowed?
    return
  end
  @stateptr += 1
  @statestk[@stateptr] = state
end

def state_pop()
  if (@stateptr < 0) # underflowed?
    return -1
  end
  ptr = @stateptr
  @stateptr -= 1
  return @statestk[ptr]
end

def state_drop(cnt)
  ptr = @stateptr - cnt
  if (ptr < 0)
    return
  end
  @stateptr = ptr;
end

def state_peek(relative)
  ptr = @stateptr - relative
  if (ptr < 0)
    return -1
  end
  return @statestk[ptr]
end

################################################################
# method: init_stacks : allocate and prepare stacks
################################################################
def init_stacks()
  @statestk = Array.new(YYSTACKSIZE)
  @stateptr = -1
  val_init()
  return true;
end

################################################################
# method: dump_stacks : show n levels of the stacks
################################################################
def dump_stacks(count)
  $stdout.print("=index==state====value=     s:#{@stateptr.to_s}  v:#{@valptr.to_s}\n")
  for i in 0..(count - 1)
    $stdout.print(" #{i.to_s}  #{@statestk[i].to_s}   #{@valstk[i].to_s}\n")
  end
  $stdout.print("======================\n");
end



########## SEMANTIC VALUES ##########
## **user defined:Object
#######################################################
# methods: value stack push,pop,drop,peek.
#######################################################
def val_init
  @valstk = Array.new(YYSTACKSIZE)
  @yyval=Object.new;
  @yylval=Object.new;
  @valptr=-1;
end

def val_push(val)
  if (@valptr >= YYSTACKSIZE)
    return
  end
  @valptr += 1
  @valstk[@valptr]=val
end

def val_pop
  ptr = @valptr
  if (@valptr<0)
    return nil
  else
    @valptr -= 1
    return @valstk[ptr]
  end
end

def val_drop(cnt)
  ptr = @valptr - cnt
  if (ptr < 0)
    return
  end
  @valptr = ptr
end

def val_peek(relative)
  ptr = @valptr - relative
  if (ptr < 0)
    return nil
  end
  return @valstk[ptr]
end

//#### end semantic value section ####
module Token
NUMBER=257
SYMBOL=258
end # module Token
YYERRCODE=256
def init_rule_data
@yylhs = [                           -1,
    0,    1,    1,    1,    2,    2,    2,    3,    3,
]
@yylen = [                            2,
    1,    1,    3,    0,    3,    3,    1,    1,    1,
]
end
def init_yydefred
@yydefred = [                         0,
    8,    0,    0,    1,    2,    0,    0,    0,    0,    9,
    3,    5,    6,
]
end
def init_yydgoto
@yydgoto = [                          3,
    4,    5,    6,
]
end
def init_base
@yysindex = [                      -254,
    0,  -52,    0,    0,    0,  -43, -252, -252, -252,    0,
    0,    0,    0,
]
@yyrindex = [                        10,
    0,    1,    0,    0,    0,   11,    0,    0,    0,    0,
    0,    0,    0,
]
@yygindex = [                         0,
    0,    5,   -1,
]
end
YYTABLESIZE = 46
def init_table
@yytable = [                          8,
    9,    9,    1,    2,    1,   10,   12,   13,    7,    4,
    7,   11,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    9,    0,    9,
]
end
def init_check
@yycheck = [                         43,
    0,   45,  257,  258,  257,  258,    8,    9,   61,    0,
    0,    7,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   43,   -1,   45,
]
end
YYFINAL=3
if( ! defined?(YYDEBUG) )
  YYDEBUG = 0
end
YYMAXTOKEN=258
def init_yyname
@yyname = [
"end-of-file",nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,"'+'",nil,
"'-'",nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,"'='",nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,"NUMBER","SYMBOL",
]
end
def init_yyrule
@yyrule = [
"$accept : program",
"program : stm",
"stm : expr",
"stm : SYMBOL '=' expr",
"stm :",
"expr : term '+' term",
"expr : term '-' term",
"expr : term",
"term : NUMBER",
"term : SYMBOL",
]

end
################################################################
# method: yylexdebug : check lexer state
################################################################
def yylexdebug(state, ch)
  s = nil
  if (ch < 0); ch = 0; end
  if (ch <= YYMAXTOKEN) # check index bounds
     s = @yyname[ch]    # now get it
  end
  if (s == nil)
    s = "illegal-symbol"
  end
  debug("state #{state}, reading #{ch} (#{s})")
end


################################################################
# method: yyparse : parse input and execute indicated items
################################################################
def yyparse()
  @yyn = nil     # next next thing to do
  @yym = nil
  @yystate = nil # current parsing state from state table
  @yys = nil     # current token string
  doaction = nil
  init_stacks()
  @yynerrs = 0
  @yyerrflag = 0
  @yychar = -1          # impossible char forces a read
  @yystate=0            # initial state
  state_push(@yystate)  # save it
  while (true) # until parsing is done, either correctly, or w/error
    doaction = true
    if (@yydebug)
      debug("loop")
    end
    ##### NEXT ACTION (from reduction table)
    while( (@yyn = @yydefred[@yystate]) && (@yyn == 0) )
      if (@yydebug)
        debug("yyn:#{@yyn}  state:#{@yystate}  char:#{@yychar}")
      end
      if (@yychar < 0)      # we want a char?
        @yychar = yylex()   # get next token
        ##### ERROR CHECK ####
        if (@yychar < 0)    # it it didn't work/error
          @yychar = 0;      # change it to default string (no -1!)
          if (@yydebug)
            yylexdebug(@yystate, @yychar)
          end
        end # @yychar<0
      end # @yychar<0
      @yyn = @yysindex[@yystate]   # get amount to shift by (shift index)
      if ((@yyn != 0) && ((@yyn += @yychar) >= 0) &&
          (@yyn <= YYTABLESIZE) && (@yycheck[@yyn] == @yychar))
        if (@yydebug)
          debug("state #{@yystate}, shifting to state #{@yytable[@yyn]}")
        end
        ##### NEXT STATE ####
        @yystate = @yytable[@yyn] # we are in a new state
        state_push(@yystate)    # save it
        val_push(@yylval)       # push our lval as the input for next rule
        @yychar = -1  # since we have 'eaten' a token, say we need another
        if (@yyerrflag > 0)     # have we recovered an error?
           @yyerrflag -= 1      # give ourselves credit
        end
        doaction = false       # but don't process yet
        break                  # quit the yyn=0 loop
      end  # if((@yyn != 0)....)

      @yyn = @yyrindex[@yystate]  # reduce
      if ((@yyn !=0 ) && ((@yyn += @yychar) >= 0) &&
          (@yyn <= YYTABLESIZE) && (@yycheck[@yyn] == @yychar))
        if (@yydebug)
          debug("reduce")
        end
        @yyn = @yytable[@yyn]
        doaction=true  # get ready to execute
        break          # drop down to actions
      else # ERROR RECOVERY
        if (@yyerrflag==0)
          yyerror("syntax error")
          @yynerrs += 1
        end
        if (@yyerrflag < 3) # low error count?
          @yyerrflag = 3
          while (true)      # do until break
            if (@stateptr<0) # check for under & overflow here
              yyerror("stack underflow. aborting...") # note lower case 's'
              return 1
            end
            @yyn = @yysindex[state_peek(0)]
            if ((@yyn != 0) && ((@yyn += YYERRCODE) >= 0) &&
                (@yyn <= YYTABLESIZE) && (@yycheck[@yyn] == YYERRCODE))
              if (@yydebug)
                debug("state #{state_peek(0)}, error recovery shifting to state #{yytable[yyn]}")
              end
              @yystate = @yytable[@yyn]
              state_push(@yystate)
              val_push(@yylval)
              doaction = false
              break
            else
              if (@yydebug)
                debug("error recovery discarding state #{state_peek(0)}")
              end
              if (@stateptr<0)   # check for under & overflow here
                yyerror("Stack underflow. aborting...")  # capital 'S'
                return 1
              end
              state_pop()
              val_pop()
            end
          end # while(true)
        else            # discard this token
          if (@yychar == 0)
            return 1 # yyabort
          end
          if (@yydebug)
            @yys = nil
            if (@yychar <= YYMAXTOKEN)
              @yys = @yyname[@yychar]
            end
            if (@yys == nil)
              @yys = "illegal-symbol"
            end
            debug("state #{@yystate}, error recovery discards token #{@yychar} (#{@yys}")
          end
          @yychar = -1 # read another
        end
      end # End of ERROR RECOVERY
    end # while(@yyn==0) loop
    if (!doaction)   # any reason not to proceed?
      next           # skip action (continue in Java)
    end
    @yym = @yylen[@yyn] # get count of terminals on rhs
    if (@yydebug)
      debug("state #{@yystate}, reducing #{@yym} by rule #{@yyn} (#{@yyrule[@yyn]})")
    end
    if (@yym > 0)                 # if count of rhs not 'nil'
      @yyval = val_peek(@yym-1)   # get current semantic value
    end
    case @yyn
########### USER-SUPPLIED ACTIONS ##########
when 1
#line 11 "cal.y"
  $result = val_peek(0)  
when 2
#line 15 "cal.y"
  @yyval = val_peek(0)  
when 3
#line 16 "cal.y"
  $SYMBOL_TABLE[val_peek(2)] = val_peek(0)  
when 5
#line 21 "cal.y"
  @yyval = val_peek(2) + val_peek(0)  
when 6
#line 22 "cal.y"
  @yyval = val_peek(2) - val_peek(0)  
when 7
#line 23 "cal.y"
  @yyval = val_peek(0)  
when 8
#line 27 "cal.y"
  @yyval = @yylval.to_i  
when 9
#line 28 "cal.y"
 
           if SYMBOL_TABLE[val_peek(0)]
              @yyval = SYMBOL_TABLE[val_peek(0)]
           else
              raise(RuntimeError,"can't find symbol")
           end
          
#line 367 "Parser.rb"
########## END OF USER-SUPPLIED ACTIONS ##########
    end # case(@yyn)
    ##### Now let's reduce... ####
    if (@yydebug); debug("reduce"); end
    state_drop(@yym)              # we just reduced yylen states
    @yystate = state_peek(0)      # get new state
    val_drop(@yym)                # corresponding value drop
    @yym = @yylhs[@yyn]             # select next TERMINAL(on lhs)
    if ((@yystate == 0) && (@yym == 0))# done? 'rest' state and at first TERMINAL
      debug("After reduction, shifting from state 0 to state #{YYFINAL}")
      @yystate = YYFINAL          # explicitly say we're done
      state_push(YYFINAL)        # and save it
      val_push(@yyval)            # also save the semantic value of parsing
      if (@yychar < 0)            # we want another character?
        @yychar = yylex()         # get next character
        if (@yychar < 0)
          @yychar = 0               # clean, if necessary
        end
        if (@yydebug)
          yylexdebug(@yystate, @yychar)
        end
      end
      if (@yychar == 0)           # Good exit (if lex returns 0 ;-)
         break                   # quit the loop--all DONE
      end
    else                         # if yystate (else not done yet)
      @yyn = @yygindex[@yym]        # find out where to go
      if ((@yyn != 0) && (@yyn += @yystate) >= 0 &&
          (@yyn <= YYTABLESIZE) && (@yycheck[@yyn] == @yystate))
        @yystate = @yytable[@yyn]   # get new state
      else
        @yystate = @yydgoto[@yym]   # else go to new defred
      end
      debug("after reduction, shifting from state #{state_peek(0)} to state #{@yystate}")
      state_push(@yystate)        # going again, so push state & val...
      val_push(@yyval)            # for next action
    end # else
  end # main loop
  return 0 # yyaccept!!
end
### end of method parse() ######################################



end
#################### END OF CLASS yaccpar ######################
